// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: DetailReportDayCache.proto

package ru.omnicomm.pegasus.messaging.data.responses.reportcache;

public final class DetailReportDayCacheParser {
  private DetailReportDayCacheParser() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public static final class DetailReportDayCache extends
      com.google.protobuf.GeneratedMessage {
    // Use DetailReportDayCache.newBuilder() to construct.
    private DetailReportDayCache() {
      initFields();
    }
    private DetailReportDayCache(boolean noInit) {}
    
    private static final DetailReportDayCache defaultInstance;
    public static DetailReportDayCache getDefaultInstance() {
      return defaultInstance;
    }
    
    public DetailReportDayCache getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_reportcache_DetailReportDayCache_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_reportcache_DetailReportDayCache_fieldAccessorTable;
    }
    
    // required int32 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private boolean hasSourceId;
    private int sourceId_ = 0;
    public boolean hasSourceId() { return hasSourceId; }
    public int getSourceId() { return sourceId_; }
    
    // optional int32 messageType = 2 [default = 1002];
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private boolean hasMessageType;
    private int messageType_ = 1002;
    public boolean hasMessageType() { return hasMessageType; }
    public int getMessageType() { return messageType_; }
    
    // required int32 messageTime = 3;
    public static final int MESSAGETIME_FIELD_NUMBER = 3;
    private boolean hasMessageTime;
    private int messageTime_ = 0;
    public boolean hasMessageTime() { return hasMessageTime; }
    public int getMessageTime() { return messageTime_; }
    
    // repeated .ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDataItem items = 101;
    public static final int ITEMS_FIELD_NUMBER = 101;
    private java.util.List<ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem> items_ =
      java.util.Collections.emptyList();
    public java.util.List<ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem> getItemsList() {
      return items_;
    }
    public int getItemsCount() { return items_.size(); }
    public ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem getItems(int index) {
      return items_.get(index);
    }
    
    private void initFields() {
    }
    public final boolean isInitialized() {
      if (!hasSourceId) return false;
      if (!hasMessageTime) return false;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (hasSourceId()) {
        output.writeInt32(1, getSourceId());
      }
      if (hasMessageType()) {
        output.writeInt32(2, getMessageType());
      }
      if (hasMessageTime()) {
        output.writeInt32(3, getMessageTime());
      }
      for (ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem element : getItemsList()) {
        output.writeMessage(101, element);
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (hasSourceId()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(1, getSourceId());
      }
      if (hasMessageType()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, getMessageType());
      }
      if (hasMessageTime()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, getMessageTime());
      }
      for (ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem element : getItemsList()) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(101, element);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder> {
      private ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache result;
      
      // Construct using ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache.newBuilder()
      private Builder() {}
      
      private static Builder create() {
        Builder builder = new Builder();
        builder.result = new ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache();
        return builder;
      }
      
      protected ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache internalGetResult() {
        return result;
      }
      
      public Builder clear() {
        if (result == null) {
          throw new IllegalStateException(
            "Cannot call clear() after build().");
        }
        result = new ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache();
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(result);
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache.getDefaultInstance();
      }
      
      public boolean isInitialized() {
        return result.isInitialized();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache build() {
        if (result != null && !isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return buildPartial();
      }
      
      private ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        if (!isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return buildPartial();
      }
      
      public ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache buildPartial() {
        if (result == null) {
          throw new IllegalStateException(
            "build() has already been called on this Builder.");
        }
        if (result.items_ != java.util.Collections.EMPTY_LIST) {
          result.items_ =
            java.util.Collections.unmodifiableList(result.items_);
        }
        ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache returnMe = result;
        result = null;
        return returnMe;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache other) {
        if (other == ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasMessageTime()) {
          setMessageTime(other.getMessageTime());
        }
        if (!other.items_.isEmpty()) {
          if (result.items_.isEmpty()) {
            result.items_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem>();
          }
          result.items_.addAll(other.items_);
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                return this;
              }
              break;
            }
            case 8: {
              setSourceId(input.readInt32());
              break;
            }
            case 16: {
              setMessageType(input.readInt32());
              break;
            }
            case 24: {
              setMessageTime(input.readInt32());
              break;
            }
            case 810: {
              ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem.Builder subBuilder = ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem.newBuilder();
              input.readMessage(subBuilder, extensionRegistry);
              addItems(subBuilder.buildPartial());
              break;
            }
          }
        }
      }
      
      
      // required int32 sourceId = 1;
      public boolean hasSourceId() {
        return result.hasSourceId();
      }
      public int getSourceId() {
        return result.getSourceId();
      }
      public Builder setSourceId(int value) {
        result.hasSourceId = true;
        result.sourceId_ = value;
        return this;
      }
      public Builder clearSourceId() {
        result.hasSourceId = false;
        result.sourceId_ = 0;
        return this;
      }
      
      // optional int32 messageType = 2 [default = 1002];
      public boolean hasMessageType() {
        return result.hasMessageType();
      }
      public int getMessageType() {
        return result.getMessageType();
      }
      public Builder setMessageType(int value) {
        result.hasMessageType = true;
        result.messageType_ = value;
        return this;
      }
      public Builder clearMessageType() {
        result.hasMessageType = false;
        result.messageType_ = 1002;
        return this;
      }
      
      // required int32 messageTime = 3;
      public boolean hasMessageTime() {
        return result.hasMessageTime();
      }
      public int getMessageTime() {
        return result.getMessageTime();
      }
      public Builder setMessageTime(int value) {
        result.hasMessageTime = true;
        result.messageTime_ = value;
        return this;
      }
      public Builder clearMessageTime() {
        result.hasMessageTime = false;
        result.messageTime_ = 0;
        return this;
      }
      
      // repeated .ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDataItem items = 101;
      public java.util.List<ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem> getItemsList() {
        return java.util.Collections.unmodifiableList(result.items_);
      }
      public int getItemsCount() {
        return result.getItemsCount();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem getItems(int index) {
        return result.getItems(index);
      }
      public Builder setItems(int index, ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.items_.set(index, value);
        return this;
      }
      public Builder setItems(int index, ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem.Builder builderForValue) {
        result.items_.set(index, builderForValue.build());
        return this;
      }
      public Builder addItems(ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem value) {
        if (value == null) {
          throw new NullPointerException();
        }
        if (result.items_.isEmpty()) {
          result.items_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem>();
        }
        result.items_.add(value);
        return this;
      }
      public Builder addItems(ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem.Builder builderForValue) {
        if (result.items_.isEmpty()) {
          result.items_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem>();
        }
        result.items_.add(builderForValue.build());
        return this;
      }
      public Builder addAllItems(
          java.lang.Iterable<? extends ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem> values) {
        if (result.items_.isEmpty()) {
          result.items_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem>();
        }
        super.addAll(values, result.items_);
        return this;
      }
      public Builder clearItems() {
        result.items_ = java.util.Collections.emptyList();
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCache)
    }
    
    static {
      defaultInstance = new DetailReportDayCache(true);
      ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.internalForceInit();
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCache)
  }
  
  public static final class DetailReportDataItem extends
      com.google.protobuf.GeneratedMessage {
    // Use DetailReportDataItem.newBuilder() to construct.
    private DetailReportDataItem() {
      initFields();
    }
    private DetailReportDataItem(boolean noInit) {}
    
    private static final DetailReportDataItem defaultInstance;
    public static DetailReportDataItem getDefaultInstance() {
      return defaultInstance;
    }
    
    public DetailReportDataItem getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_reportcache_DetailReportDataItem_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_reportcache_DetailReportDataItem_fieldAccessorTable;
    }
    
    // optional int32 intervalTime = 1;
    public static final int INTERVALTIME_FIELD_NUMBER = 1;
    private boolean hasIntervalTime;
    private int intervalTime_ = 0;
    public boolean hasIntervalTime() { return hasIntervalTime; }
    public int getIntervalTime() { return intervalTime_; }
    
    // optional int32 intervalLength = 2;
    public static final int INTERVALLENGTH_FIELD_NUMBER = 2;
    private boolean hasIntervalLength;
    private int intervalLength_ = 0;
    public boolean hasIntervalLength() { return hasIntervalLength; }
    public int getIntervalLength() { return intervalLength_; }
    
    // optional int32 intervalType = 3;
    public static final int INTERVALTYPE_FIELD_NUMBER = 3;
    private boolean hasIntervalType;
    private int intervalType_ = 0;
    public boolean hasIntervalType() { return hasIntervalType; }
    public int getIntervalType() { return intervalType_; }
    
    // optional int64 mileage = 4;
    public static final int MILEAGE_FIELD_NUMBER = 4;
    private boolean hasMileage;
    private long mileage_ = 0L;
    public boolean hasMileage() { return hasMileage; }
    public long getMileage() { return mileage_; }
    
    // optional int64 maxVelocity = 5;
    public static final int MAXVELOCITY_FIELD_NUMBER = 5;
    private boolean hasMaxVelocity;
    private long maxVelocity_ = 0L;
    public boolean hasMaxVelocity() { return hasMaxVelocity; }
    public long getMaxVelocity() { return maxVelocity_; }
    
    // optional int64 latitudeFrom = 6;
    public static final int LATITUDEFROM_FIELD_NUMBER = 6;
    private boolean hasLatitudeFrom;
    private long latitudeFrom_ = 0L;
    public boolean hasLatitudeFrom() { return hasLatitudeFrom; }
    public long getLatitudeFrom() { return latitudeFrom_; }
    
    // optional int64 longitudeFrom = 8;
    public static final int LONGITUDEFROM_FIELD_NUMBER = 8;
    private boolean hasLongitudeFrom;
    private long longitudeFrom_ = 0L;
    public boolean hasLongitudeFrom() { return hasLongitudeFrom; }
    public long getLongitudeFrom() { return longitudeFrom_; }
    
    // optional int64 latitudeTill = 9;
    public static final int LATITUDETILL_FIELD_NUMBER = 9;
    private boolean hasLatitudeTill;
    private long latitudeTill_ = 0L;
    public boolean hasLatitudeTill() { return hasLatitudeTill; }
    public long getLatitudeTill() { return latitudeTill_; }
    
    // optional int64 longitudeTill = 10;
    public static final int LONGITUDETILL_FIELD_NUMBER = 10;
    private boolean hasLongitudeTill;
    private long longitudeTill_ = 0L;
    public boolean hasLongitudeTill() { return hasLongitudeTill; }
    public long getLongitudeTill() { return longitudeTill_; }
    
    private void initFields() {
    }
    public final boolean isInitialized() {
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (hasIntervalTime()) {
        output.writeInt32(1, getIntervalTime());
      }
      if (hasIntervalLength()) {
        output.writeInt32(2, getIntervalLength());
      }
      if (hasIntervalType()) {
        output.writeInt32(3, getIntervalType());
      }
      if (hasMileage()) {
        output.writeInt64(4, getMileage());
      }
      if (hasMaxVelocity()) {
        output.writeInt64(5, getMaxVelocity());
      }
      if (hasLatitudeFrom()) {
        output.writeInt64(6, getLatitudeFrom());
      }
      if (hasLongitudeFrom()) {
        output.writeInt64(8, getLongitudeFrom());
      }
      if (hasLatitudeTill()) {
        output.writeInt64(9, getLatitudeTill());
      }
      if (hasLongitudeTill()) {
        output.writeInt64(10, getLongitudeTill());
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (hasIntervalTime()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(1, getIntervalTime());
      }
      if (hasIntervalLength()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, getIntervalLength());
      }
      if (hasIntervalType()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, getIntervalType());
      }
      if (hasMileage()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(4, getMileage());
      }
      if (hasMaxVelocity()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(5, getMaxVelocity());
      }
      if (hasLatitudeFrom()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(6, getLatitudeFrom());
      }
      if (hasLongitudeFrom()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(8, getLongitudeFrom());
      }
      if (hasLatitudeTill()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(9, getLatitudeTill());
      }
      if (hasLongitudeTill()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(10, getLongitudeTill());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder> {
      private ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem result;
      
      // Construct using ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem.newBuilder()
      private Builder() {}
      
      private static Builder create() {
        Builder builder = new Builder();
        builder.result = new ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem();
        return builder;
      }
      
      protected ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem internalGetResult() {
        return result;
      }
      
      public Builder clear() {
        if (result == null) {
          throw new IllegalStateException(
            "Cannot call clear() after build().");
        }
        result = new ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem();
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(result);
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem.getDefaultInstance();
      }
      
      public boolean isInitialized() {
        return result.isInitialized();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem build() {
        if (result != null && !isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return buildPartial();
      }
      
      private ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        if (!isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return buildPartial();
      }
      
      public ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem buildPartial() {
        if (result == null) {
          throw new IllegalStateException(
            "build() has already been called on this Builder.");
        }
        ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem returnMe = result;
        result = null;
        return returnMe;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem other) {
        if (other == ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem.getDefaultInstance()) return this;
        if (other.hasIntervalTime()) {
          setIntervalTime(other.getIntervalTime());
        }
        if (other.hasIntervalLength()) {
          setIntervalLength(other.getIntervalLength());
        }
        if (other.hasIntervalType()) {
          setIntervalType(other.getIntervalType());
        }
        if (other.hasMileage()) {
          setMileage(other.getMileage());
        }
        if (other.hasMaxVelocity()) {
          setMaxVelocity(other.getMaxVelocity());
        }
        if (other.hasLatitudeFrom()) {
          setLatitudeFrom(other.getLatitudeFrom());
        }
        if (other.hasLongitudeFrom()) {
          setLongitudeFrom(other.getLongitudeFrom());
        }
        if (other.hasLatitudeTill()) {
          setLatitudeTill(other.getLatitudeTill());
        }
        if (other.hasLongitudeTill()) {
          setLongitudeTill(other.getLongitudeTill());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                return this;
              }
              break;
            }
            case 8: {
              setIntervalTime(input.readInt32());
              break;
            }
            case 16: {
              setIntervalLength(input.readInt32());
              break;
            }
            case 24: {
              setIntervalType(input.readInt32());
              break;
            }
            case 32: {
              setMileage(input.readInt64());
              break;
            }
            case 40: {
              setMaxVelocity(input.readInt64());
              break;
            }
            case 48: {
              setLatitudeFrom(input.readInt64());
              break;
            }
            case 64: {
              setLongitudeFrom(input.readInt64());
              break;
            }
            case 72: {
              setLatitudeTill(input.readInt64());
              break;
            }
            case 80: {
              setLongitudeTill(input.readInt64());
              break;
            }
          }
        }
      }
      
      
      // optional int32 intervalTime = 1;
      public boolean hasIntervalTime() {
        return result.hasIntervalTime();
      }
      public int getIntervalTime() {
        return result.getIntervalTime();
      }
      public Builder setIntervalTime(int value) {
        result.hasIntervalTime = true;
        result.intervalTime_ = value;
        return this;
      }
      public Builder clearIntervalTime() {
        result.hasIntervalTime = false;
        result.intervalTime_ = 0;
        return this;
      }
      
      // optional int32 intervalLength = 2;
      public boolean hasIntervalLength() {
        return result.hasIntervalLength();
      }
      public int getIntervalLength() {
        return result.getIntervalLength();
      }
      public Builder setIntervalLength(int value) {
        result.hasIntervalLength = true;
        result.intervalLength_ = value;
        return this;
      }
      public Builder clearIntervalLength() {
        result.hasIntervalLength = false;
        result.intervalLength_ = 0;
        return this;
      }
      
      // optional int32 intervalType = 3;
      public boolean hasIntervalType() {
        return result.hasIntervalType();
      }
      public int getIntervalType() {
        return result.getIntervalType();
      }
      public Builder setIntervalType(int value) {
        result.hasIntervalType = true;
        result.intervalType_ = value;
        return this;
      }
      public Builder clearIntervalType() {
        result.hasIntervalType = false;
        result.intervalType_ = 0;
        return this;
      }
      
      // optional int64 mileage = 4;
      public boolean hasMileage() {
        return result.hasMileage();
      }
      public long getMileage() {
        return result.getMileage();
      }
      public Builder setMileage(long value) {
        result.hasMileage = true;
        result.mileage_ = value;
        return this;
      }
      public Builder clearMileage() {
        result.hasMileage = false;
        result.mileage_ = 0L;
        return this;
      }
      
      // optional int64 maxVelocity = 5;
      public boolean hasMaxVelocity() {
        return result.hasMaxVelocity();
      }
      public long getMaxVelocity() {
        return result.getMaxVelocity();
      }
      public Builder setMaxVelocity(long value) {
        result.hasMaxVelocity = true;
        result.maxVelocity_ = value;
        return this;
      }
      public Builder clearMaxVelocity() {
        result.hasMaxVelocity = false;
        result.maxVelocity_ = 0L;
        return this;
      }
      
      // optional int64 latitudeFrom = 6;
      public boolean hasLatitudeFrom() {
        return result.hasLatitudeFrom();
      }
      public long getLatitudeFrom() {
        return result.getLatitudeFrom();
      }
      public Builder setLatitudeFrom(long value) {
        result.hasLatitudeFrom = true;
        result.latitudeFrom_ = value;
        return this;
      }
      public Builder clearLatitudeFrom() {
        result.hasLatitudeFrom = false;
        result.latitudeFrom_ = 0L;
        return this;
      }
      
      // optional int64 longitudeFrom = 8;
      public boolean hasLongitudeFrom() {
        return result.hasLongitudeFrom();
      }
      public long getLongitudeFrom() {
        return result.getLongitudeFrom();
      }
      public Builder setLongitudeFrom(long value) {
        result.hasLongitudeFrom = true;
        result.longitudeFrom_ = value;
        return this;
      }
      public Builder clearLongitudeFrom() {
        result.hasLongitudeFrom = false;
        result.longitudeFrom_ = 0L;
        return this;
      }
      
      // optional int64 latitudeTill = 9;
      public boolean hasLatitudeTill() {
        return result.hasLatitudeTill();
      }
      public long getLatitudeTill() {
        return result.getLatitudeTill();
      }
      public Builder setLatitudeTill(long value) {
        result.hasLatitudeTill = true;
        result.latitudeTill_ = value;
        return this;
      }
      public Builder clearLatitudeTill() {
        result.hasLatitudeTill = false;
        result.latitudeTill_ = 0L;
        return this;
      }
      
      // optional int64 longitudeTill = 10;
      public boolean hasLongitudeTill() {
        return result.hasLongitudeTill();
      }
      public long getLongitudeTill() {
        return result.getLongitudeTill();
      }
      public Builder setLongitudeTill(long value) {
        result.hasLongitudeTill = true;
        result.longitudeTill_ = value;
        return this;
      }
      public Builder clearLongitudeTill() {
        result.hasLongitudeTill = false;
        result.longitudeTill_ = 0L;
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDataItem)
    }
    
    static {
      defaultInstance = new DetailReportDataItem(true);
      ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.internalForceInit();
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDataItem)
  }
  
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_data_responses_reportcache_DetailReportDayCache_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_data_responses_reportcache_DetailReportDayCache_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_data_responses_reportcache_DetailReportDataItem_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_data_responses_reportcache_DetailReportDataItem_fieldAccessorTable;
  
  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\032DetailReportDayCache.proto\0228ru.omnicom" +
      "m.pegasus.messaging.data.responses.repor" +
      "tcache\"\267\001\n\024DetailReportDayCache\022\020\n\010sourc" +
      "eId\030\001 \002(\005\022\031\n\013messageType\030\002 \001(\005:\0041002\022\023\n\013" +
      "messageTime\030\003 \002(\005\022]\n\005items\030e \003(\0132N.ru.om" +
      "nicomm.pegasus.messaging.data.responses." +
      "reportcache.DetailReportDataItem\"\332\001\n\024Det" +
      "ailReportDataItem\022\024\n\014intervalTime\030\001 \001(\005\022" +
      "\026\n\016intervalLength\030\002 \001(\005\022\024\n\014intervalType\030" +
      "\003 \001(\005\022\017\n\007mileage\030\004 \001(\003\022\023\n\013maxVelocity\030\005 ",
      "\001(\003\022\024\n\014latitudeFrom\030\006 \001(\003\022\025\n\rlongitudeFr" +
      "om\030\010 \001(\003\022\024\n\014latitudeTill\030\t \001(\003\022\025\n\rlongit" +
      "udeTill\030\n \001(\003BV\n8ru.omnicomm.pegasus.mes" +
      "saging.data.responses.reportcacheB\032Detai" +
      "lReportDayCacheParser"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_reportcache_DetailReportDayCache_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_reportcache_DetailReportDayCache_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_data_responses_reportcache_DetailReportDayCache_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "MessageTime", "Items", },
              ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache.class,
              ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDayCache.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_reportcache_DetailReportDataItem_descriptor =
            getDescriptor().getMessageTypes().get(1);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_reportcache_DetailReportDataItem_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_data_responses_reportcache_DetailReportDataItem_descriptor,
              new java.lang.String[] { "IntervalTime", "IntervalLength", "IntervalType", "Mileage", "MaxVelocity", "LatitudeFrom", "LongitudeFrom", "LatitudeTill", "LongitudeTill", },
              ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem.class,
              ru.omnicomm.pegasus.messaging.data.responses.reportcache.DetailReportDayCacheParser.DetailReportDataItem.Builder.class);
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }
  
  public static void internalForceInit() {}
  
  // @@protoc_insertion_point(outer_class_scope)
}
